#!/usr/bin/perl -w

#
# (c) Dr. Boris Neubert 2009 omega at online dot de
#
# This is a companion program to the WLSP-CSM firmware.
# A character stream is taken from stdin and send to
# the CSM device in 25byte chunks making use of a CUL
# device.
#

# device file of CUL
my $device= "/dev/ttyACM0";

# nothing to change below this line
#-------------------------------------------------------

#my $lockfile= "/tmp/lock";

use Device::SerialPort;


sub CULWrite($$) {
	my ($port,$msg)= @_;
	$port->write($msg . "\n");
	select(undef, undef, undef, 0.1); # 0.1= slow
}

sub CULRead($) {
	my ($port)= @_;
	my $msg= $port->input();
	chomp $msg;
	return $msg;
}


my $port= Device::SerialPort->new($device)#, 0, $lockfile)
	|| die "Cannot open $device: $!\n";
$port->baudrate(9600);
$port->databits(8);
$port->parity("none");
$port->stopbits(1);
$port->handshake("none");

CULWrite($port,"V");
my $version= CULRead($port);
print("CUL Version: $version\n");

CULWrite($port,"fr");
while(<STDIN>) {
	my $msg= $_;
	my $i= 0;
	my $length= length($msg);
	do {
		my $l= $length-$i;
		if($l>25) { $l= 25; }
		my $part= substr $msg, $i, $l;
		CULWrite($port, "fs" . $part);
		print "$part\n";
		$i+= 25;
	} until($i>=$length);
}
$port->close || warn "close failed";
undef $port;


